"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var transformLayoutStyleProperties_1 = require("../../styleTransformers/transformLayoutStyleProperties");
var useYogaLayout_1 = require("../../hooks/useYogaLayout");
var transformBlendProperties_1 = require("../../styleTransformers/transformBlendProperties");
var __1 = require("../..");
var transformGeometryStyleProperties_1 = require("../../styleTransformers/transformGeometryStyleProperties");
var useSelectionChange_1 = require("../../hooks/useSelectionChange");
exports.Group = function (props) {
    var nodeRef = React.useRef();
    useSelectionChange_1.useSelectionChange(nodeRef, props);
    var style = __1.StyleSheet.flatten(props.style);
    var groupProps = __assign({}, transformLayoutStyleProperties_1.transformLayoutStyleProperties(style), transformBlendProperties_1.transformBlendProperties(style), transformGeometryStyleProperties_1.transformGeometryStyleProperties('backgrounds', style), props);
    var yogaChildProps = useYogaLayout_1.useYogaLayout(__assign({ nodeRef: nodeRef }, groupProps));
    return React.createElement("group", __assign({}, groupProps, yogaChildProps, { innerRef: nodeRef }));
};
//# sourceMappingURL=Group.js.map