"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var useYogaLayout_1 = require("../../hooks/useYogaLayout");
exports.useCurrentPageChange = function (nodeRef, callback) {
    var didMountRef = React.useRef(false);
    var _a = React.useState(false), isCurrent = _a[0], setIsCurrent = _a[1];
    React.useEffect(function () {
        if (!didMountRef.current) {
            didMountRef.current = true;
            return;
        }
        callback && callback(isCurrent);
    }, [isCurrent]);
    React.useEffect(function () {
        var handler = function () {
            setIsCurrent(figma.currentPage === nodeRef.current);
        };
        figma.on('currentpagechange', handler);
        return function () { return figma.off('currentpagechange', handler); };
    }, [callback]);
};
exports.Page = function (props) {
    var nodeRef = React.useRef();
    exports.useCurrentPageChange(nodeRef, props.onCurrentChange);
    var yogaChildProps = useYogaLayout_1.useYogaLayout(__assign({ nodeRef: nodeRef }, props));
    return React.createElement("page", __assign({}, props, yogaChildProps, { innerRef: nodeRef }));
};
//# sourceMappingURL=Page.js.map