import * as React from 'react';
import { DefaultShapeProps, BorderProps, CornerProps, StyleOf, InstanceItemProps, SelectionEventProps } from '../../types';
import { LayoutStyleProperties } from '../../styleTransformers/transformLayoutStyleProperties';
import { GeometryStyleProperties } from '../../styleTransformers/transformGeometryStyleProperties';
import { BorderStyleProperties } from '../../styleTransformers/transformBorderProperties';
import { BlendStyleProperties } from '../../styleTransformers/transformBlendProperties';
import { YogaStyleProperties } from '../../yoga/YogaStyleProperties';
export interface RectangleProps extends DefaultShapeProps, CornerProps, BorderProps, InstanceItemProps, SelectionEventProps {
    style?: StyleOf<LayoutStyleProperties & YogaStyleProperties & BorderStyleProperties & BlendStyleProperties & GeometryStyleProperties>;
    children?: undefined;
}
export declare const Rectangle: React.FC<RectangleProps>;
