import * as React from 'react';
import { DefaultShapeProps, InstanceItemProps, SelectionEventProps, StyleOf, TextNodeProps } from '../../types';
import { LayoutStyleProperties } from '../../styleTransformers/transformLayoutStyleProperties';
import { TextStyleProperties } from '../../styleTransformers/transformTextStyleProperties';
import { BlendStyleProperties } from '../../styleTransformers/transformBlendProperties';
import { YogaStyleProperties } from '../../yoga/YogaStyleProperties';
export interface TextProps extends TextNodeProps, DefaultShapeProps, InstanceItemProps, SelectionEventProps {
    style?: StyleOf<YogaStyleProperties & LayoutStyleProperties & TextStyleProperties & BlendStyleProperties> | void;
    children?: string;
    node?: any;
    preventResizing?: boolean;
}
export declare const Text: React.FC<TextProps>;
