"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var transformLayoutStyleProperties_1 = require("../../styleTransformers/transformLayoutStyleProperties");
var transformTextStyleProperties_1 = require("../../styleTransformers/transformTextStyleProperties");
var useYogaLayout_1 = require("../../hooks/useYogaLayout");
var transformBlendProperties_1 = require("../../styleTransformers/transformBlendProperties");
var __1 = require("../..");
var useFontName_1 = require("../../hooks/useFontName");
var useTextChildren_1 = require("../../hooks/useTextChildren");
var useSelectionChange_1 = require("../../hooks/useSelectionChange");
exports.Text = function (props) {
    var nodeRef = React.useRef();
    useSelectionChange_1.useSelectionChange(nodeRef, props);
    var style = __1.StyleSheet.flatten(props.style);
    var charactersByChildren = useTextChildren_1.useTextChildren(nodeRef);
    var textProps = __assign({}, transformLayoutStyleProperties_1.transformLayoutStyleProperties(style), transformTextStyleProperties_1.transformTextStyleProperties(style), transformBlendProperties_1.transformBlendProperties(style), props, { characters: charactersByChildren || props.characters });
    var hasDefinedWidth = textProps.width || style.maxWidth;
    var loadedFont = useFontName_1.useFontName(textProps.fontName || { family: 'Roboto', style: 'Regular' });
    var yogaProps = useYogaLayout_1.useYogaLayout(__assign({ nodeRef: nodeRef }, textProps));
    return (React.createElement("text", __assign({}, textProps, yogaProps, { hasDefinedWidth: hasDefinedWidth, loadedFont: loadedFont, innerRef: nodeRef })));
};
//# sourceMappingURL=Text.js.map