import * as React from 'react';
import { DefaultShapeProps, VectorNodeProps, CornerProps, StyleOf, InstanceItemProps, SelectionEventProps } from '../../types';
import { LayoutStyleProperties } from '../../styleTransformers/transformLayoutStyleProperties';
import { BlendStyleProperties } from '../../styleTransformers/transformBlendProperties';
import { GeometryStyleProperties } from '../../styleTransformers/transformGeometryStyleProperties';
import { YogaStyleProperties } from '../../yoga/YogaStyleProperties';
export interface VectorProps extends VectorNodeProps, DefaultShapeProps, CornerProps, InstanceItemProps, SelectionEventProps {
    style?: StyleOf<YogaStyleProperties & LayoutStyleProperties & BlendStyleProperties & GeometryStyleProperties>;
    children?: undefined;
}
export declare const Vector: React.FC<VectorProps>;
