"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var transformLayoutStyleProperties_1 = require("../../styleTransformers/transformLayoutStyleProperties");
var useYogaLayout_1 = require("../../hooks/useYogaLayout");
var transformBlendProperties_1 = require("../../styleTransformers/transformBlendProperties");
var useFillsPreprocessor_1 = require("../../hooks/useFillsPreprocessor");
var transformGeometryStyleProperties_1 = require("../../styleTransformers/transformGeometryStyleProperties");
var __1 = require("../..");
var useSelectionChange_1 = require("../../hooks/useSelectionChange");
exports.Vector = function (props) {
    var nodeRef = React.useRef();
    useSelectionChange_1.useSelectionChange(nodeRef, props);
    var style = __1.StyleSheet.flatten(props.style);
    var vectorProps = __assign({}, transformLayoutStyleProperties_1.transformLayoutStyleProperties(style), transformBlendProperties_1.transformBlendProperties(style), transformGeometryStyleProperties_1.transformGeometryStyleProperties('fills', style), props);
    var fills = useFillsPreprocessor_1.useFillsPreprocessor(vectorProps);
    var yogaProps = useYogaLayout_1.useYogaLayout(__assign({ nodeRef: nodeRef }, vectorProps));
    return React.createElement("vector", __assign({}, vectorProps, yogaProps, (fills && { fills: fills }), { innerRef: nodeRef }));
};
//# sourceMappingURL=Vector.js.map