"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
exports.useSelectionChange = function (nodeRef, props) {
    var didMountRef = React.useRef(false);
    var _a = React.useState(false), isSelected = _a[0], setSelected = _a[1];
    React.useEffect(function () {
        if (!didMountRef.current) {
            didMountRef.current = true;
            return;
        }
        if (isSelected) {
            props.onSelectionEnter && props.onSelectionEnter();
        }
        else {
            props.onSelectionLeave && props.onSelectionLeave();
        }
    }, [isSelected]);
    React.useEffect(function () {
        var handler = function () {
            if (figma.currentPage.selection.indexOf(nodeRef.current) >= 0) {
                setSelected(true);
            }
            else {
                setSelected(false);
            }
        };
        figma.on('selectionchange', handler);
        return function () { return figma.off('selectionchange', handler); };
    }, [props.onSelectionEnter, props.onSelectionLeave]);
};
//# sourceMappingURL=useSelectionChange.js.map