"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var yogaStream_1 = require("../yoga/yogaStream");
var operators_1 = require("rxjs/operators");
exports.useYogaLayout = function (props) {
    var nodeRef = props.nodeRef;
    var _a = React.useState({}), yogaProps = _a[0], setYogaProps = _a[1];
    React.useEffect(function () {
        var instance = nodeRef.current;
        var subject = yogaStream_1.$updatedYogaCoords.pipe(operators_1.filter(function (message) { return message.instance === instance; }), operators_1.map(function (message) { return message.props; }));
        var subscription = subject.subscribe(setYogaProps);
        return function () { return subscription.unsubscribe(); };
    }, []);
    var didMountRef = React.useRef(false);
    React.useEffect(function () {
        if (!didMountRef.current) {
            didMountRef.current = true;
            return;
        }
        var instance = nodeRef.current;
        yogaStream_1.updateYogaNode(instance);
    }, [props.children, props.width, props.height, props.style, props.characters, props.fontSize]);
    return yogaProps;
};
//# sourceMappingURL=useYogaLayout.js.map