"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var layoutMixin_1 = require("../mixins/layoutMixin");
var refMixin_1 = require("../mixins/refMixin");
var saveStyleMixin_1 = require("../mixins/saveStyleMixin");
var baseNodeMixin_1 = require("../mixins/baseNodeMixin");
var exportMixin_1 = require("../mixins/exportMixin");
var blendMixin_1 = require("../mixins/blendMixin");
var frameMixin_1 = require("../mixins/frameMixin");
var createNewGroup = function () {
    var rect = figma.createRectangle();
    rect.setPluginData('isGroupStubElement', 'true');
    return figma.group([rect], figma.currentPage);
};
exports.group = function (node) { return function (props) {
    var frameNode = node || props.node || createNewGroup();
    refMixin_1.refMixin(frameNode)(props);
    saveStyleMixin_1.saveStyleMixin(frameNode)(props);
    baseNodeMixin_1.baseNodeMixin(frameNode)(props);
    layoutMixin_1.layoutMixin(frameNode)(props);
    exportMixin_1.exportMixin(frameNode)(props);
    blendMixin_1.blendMixin(frameNode)(props);
    frameMixin_1.frameMixin(frameNode)(props);
    return frameNode;
}; };
//# sourceMappingURL=group.js.map