"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var baseNodeMixin_1 = require("../mixins/baseNodeMixin");
var layoutMixin_1 = require("../mixins/layoutMixin");
var geometryMixin_1 = require("../mixins/geometryMixin");
var refMixin_1 = require("../mixins/refMixin");
var propsAssign_1 = require("../helpers/propsAssign");
var cornerMixin_1 = require("../mixins/cornerMixin");
var exportMixin_1 = require("../mixins/exportMixin");
var blendMixin_1 = require("../mixins/blendMixin");
var starNodePropsAssign = propsAssign_1.propsAssign(['pointCount', 'innerRadius']);
exports.star = function (node) { return function (props) {
    var starNode = node || props.node || figma.createStar();
    refMixin_1.refMixin(starNode)(props);
    baseNodeMixin_1.baseNodeMixin(starNode)(props);
    layoutMixin_1.layoutMixin(starNode)(props);
    geometryMixin_1.geometryMixin(starNode)(props);
    exportMixin_1.exportMixin(starNode)(props);
    cornerMixin_1.cornerMixin(starNode)(props);
    blendMixin_1.blendMixin(starNode)(props);
    starNodePropsAssign(starNode)(props);
    return starNode;
}; };
//# sourceMappingURL=star.js.map