"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var yogaHandler_1 = require("./yogaHandler");
var isReactFigmaNode_1 = require("../isReactFigmaNode");
var $yogaRoot = new rxjs_1.Subject();
exports.$updatedYogaCoords = new rxjs_1.Subject();
exports.updateYogaRoot = function (root) {
    $yogaRoot.next(root);
};
exports.updateYogaNode = function (node) {
    var parent = node.parent;
    if (!parent || !isReactFigmaNode_1.isReactFigmaNode(parent)) {
        exports.updateYogaRoot(node);
    }
    else {
        exports.updateYogaNode(parent);
    }
};
$yogaRoot
    .pipe(operators_1.delay(0), operators_1.concatMap(function (instance) {
    return new rxjs_1.Observable(function (subscriber) {
        var handleYogaProps = function (newProps, instance) {
            var yogaChildren = newProps.children, nodeBatchId = newProps.nodeBatchId, yogaPropsWithoutChildren = __rest(newProps, ["children", "nodeBatchId"]);
            if (instance.parent && instance.parent.type === 'GROUP') {
                yogaPropsWithoutChildren.x += instance.parent.x;
                yogaPropsWithoutChildren.y += instance.parent.y;
            }
            if (nodeBatchId != instance.getPluginData('nodeBatchId')) {
                exports.updateYogaNode(instance);
            }
            subscriber.next({ instance: instance, props: yogaPropsWithoutChildren });
            if (instance.children) {
                instance.children.forEach(function (child, index) {
                    if (!isReactFigmaNode_1.isReactFigmaNode(child)) {
                        return;
                    }
                    if (!yogaChildren || yogaChildren.length < index + 1) {
                        exports.updateYogaNode(child);
                        return;
                    }
                    handleYogaProps(yogaChildren[index], child);
                });
            }
        };
        yogaHandler_1.yogaHandler(instance).then(function (newProps) {
            handleYogaProps(newProps, instance);
            subscriber.complete();
        });
    });
}))
    .subscribe(exports.$updatedYogaCoords);
//# sourceMappingURL=yogaStream.js.map